//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_copy;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;


public class Test_Api_2_Ueh_Copy extends UiccTestModel {
    
    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_copy";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
    
    
    private USimAPITestCardService test;
    APDUResponse response;
    
        
    public Test_Api_2_Ueh_Copy() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        initialiseResults();
        
        
        // test script
        test.reset();
        test.terminalProfileSession("1719");
        
        
        // Install package
        test.loadPackage(CAP_FILE_PATH);
          
        // Install Applet
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
                           "8008" +     // TLV UICC Toolkit application specific parameters
                               "01" +   // V Priority Level
                               "00" +   // V Max. number of timers
                               "00" +   // V Maximum text length for a menu entry
                               "00" +   // V Maximum number of menu entries                              
                               "00" +   // V Install with Maximum number of channels 
                               "00" +   // LV Minimum Security Level field
                               "00" +   // LV TAR Value(s) 
                               "00" );  // V Maximum number of services
        test.reset();
        test.terminalProfileSession("1719");
        
        /**********************************************************************/
        /** Testcase 1 . Try to use the copy method with a null as            */ 
        /** parameter to dstBuffer                                            */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B2B4008 81556677 887FF600 11291200" +
                           "00041A02 70000015 0D080000 00200101" +
                           "00000000 01000A0B 0C0D0E0F 10");
        
        /**********************************************************************/
        /** Testcase 2 . Try to use copy method with a                        */     
        /** dstOffset > dstBuffer.length, dstBuffer.length = 5 dstOffset = 5  */
        /** dstLength = 1                                                     */ 
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B2B4008 81556677 887FF600 11291200" +
                           "00041A02 70000015 0D080000 00200101" +
                           "00000000 01000A0B 0C0D0E0F 10");
        
        /**********************************************************************/
        /** Testcase 3 . Try to use copy method with a dstOffset < 0  copy()  */
        /** dstBuffer.length = 5 dstOffset = -1 dstLength = 1                 */ 
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B2B4008 81556677 887FF600 11291200" +
                           "00041A02 70000015 0D080000 00200101" +
                           "00000000 01000A0B 0C0D0E0F 10");
        
        /**********************************************************************/
        /** Testcase 4 . Try to use copy method with                          */ 
        /** dstLength > dstBuffer.length, copy()dstBuffer.length = 5          */
        /** dstOffset = 0, dstLength = 6                                      */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B2B4008 81556677 887FF600 11291200" +
                           "00041A02 70000015 0D080000 00200101" +
                           "00000000 01000A0B 0C0D0E0F 10");
        
        /**********************************************************************/
        /** Testcase 5 . Try to use the copy method with                      */
        /** DstOffset + dstLength > dstBuffer.length, copy()                  */
        /** DstBuffer.length = 5, DstOffset = 3, DstLength = 3                */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B2B4008 81556677 887FF600 11291200" +
                           "00041A02 70000015 0D080000 00200101" +
                           "00000000 01000A0B 0C0D0E0F 10");  
        
        /**********************************************************************/
        /** Testcase 6 . Try to use the copy method with                      */ 
        /** dstLength < 0,   copy(), dstBuffer.length = 5, dstOffset = 0      */
        /** dstLength = -1                                                    */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B2B4008 81556677 887FF600 11291200" +
                           "00041A02 70000015 0D080000 00200101" +
                           "00000000 01000A0B 0C0D0E0F 10");  
        /**********************************************************************/
        /** Testcase 7 . Try to use the copy method with                      */ 
        /** DstLength > length of the Comprehension TLV list                  */   
        /** copy(), DstBuffer.length = 48, DstOffset = 0, DstLength = 48      */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 8 . Try to use the copy method with                      */ 
        /** Successful call, dstBuffer is the whole buffer                    */
        /** copy(), DstBuffer.length = 47, DstOffset = 0, DstLength = 47      */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        
        /**********************************************************************/
        /** Testcase 9 . Try to use the copy method                           */ 
        /** Compare the buffer                                                */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 10 . Try to use the copy method                          */ 
        /** Successful call, dstBuffer is part of a buffer                    */
        /** copy() DstBuffer.length = 50 dstOffset = 3 dstLength = 47         */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 11 . Try to use the copy method                          */ 
        /** Compare the whole buffer                                          */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 12 . Try to use the copy method with                     */ 
        /** Successful call, dstBuffer is part of a buffer                    */
        /** copy() dstBuffer.length = 15 dstOffset = 3 dstLength = 6          */
        /**********************************************************************/      
        
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 13 . Try to use the copy method with                     */
        /** Compare the whole buffer                                          */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 14 . Try to use the copy method with                     */ 
        /** Successful call, dstBuffer is part of a buffer                    */
        /** copy() dstBuffer.length = 260 dstOffset = 257 dstLength = 3       */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 15 . Try to use the copy method with                     */
        /** Compare the whole buffer                                          */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
        
        /**********************************************************************/
        /** Testcase 16 . Try to use the copy method with                     */ 
        /** Successful call, copy() with length =0   dstBuffer.length = 260   */
        /** dstOffset = 260 dstLength = 0                                     */
        /**********************************************************************/      
        //Trigger Applet1
        test.envelopeSmsPp("8B294008 81556677 887FF600 11291200" +
                           "00041802 70000013 0D080000 00200101" +
                           "00000000 01000102 030405");
          
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "10CCCCCC CCCCCCCC CCCCCCCC CCCCCC" +
                                    "CCCC"));
        
        
        test.reset();
        test.terminalProfileSession("1719");
                                         
        // Delete Applet 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();
    }
}   
