//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.toolkit.api_2_ueh_giid;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

public class Test_Api_2_Ueh_Giid extends UiccTestModel {

    static final String CAP_FILE_PATH = "uicc/usim/test/toolkit/api_2_ueh_giid";
    static final String CLASS_AID_1 = "A0000000 871005FF FFFFFF89 20010001";
    static final String APPLET_AID_1 = "A0000000 871005FF FFFFFF89 20010102";
   
    private USimAPITestCardService test;
    APDUResponse response;
      
          
    public Test_Api_2_Ueh_Giid() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }
    
    public boolean run() {
        APDUResponse data = null;
        initialiseResults();
        
        // test script
        test.reset();
        test.terminalProfileSession("09030120");


        /*********************************************************************/
        /** FORMATTED SMS PP ENV Triggering                                               */
        /*********************************************************************/

        // Install package
        test.loadPackage(CAP_FILE_PATH);
        // Install Applet
        response = test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1, 
            "8008" + // TLV UICC Toolkit application specific parameters
                "01" +   // V Priority Level
                "00" +   // V Max. number of timers
                "00" +   // V Maximum text length for a menu entry
                "00" +   // V Maximum number of menu entries                              
                "00" +   // V Install with Maximum number of channels 
                "00" +   // LV Minimum Security Level field
                "00" +   // LV TAR Value(s) 
                "00" );  // V Maximum number of services
        
        test.reset();
        test.terminalProfileSession("1719");

        // Case 1 : Send envelope formatted SMS with an item identifier TLV and identifier value of 03
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200 " +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 01001001 03");
        
        // Case 2 : Send envelope formatted SMS with two item identifier TLV with first value FF and second 44
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200" +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 01001001 FF100144");
       
        // Case 3 : Send envelope formatted SMS with two item identifier TLV with first value 81 and second 44, 
        // call twice the method getItemIdentifier()                        
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200" +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 01001001 81100144");
         
        // Case 4 : Send envelope envelope formatted SMS with item identifier TLV and value of 66. FindTLV() with TAG 02.
        // getItemIdentifier() and then getValueByte() with offset 0
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200" +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 01001001 66");


        // Case 5 : Send envelope formatted SMS without item identifier TLV and getItemIdentifier()
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200" +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 0100") ;

        // Case 6 : Send envelope formatted SMS with item identifier TLV (66), send proactive command.
        // Then getItemIdentifier()
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200" +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 01001001 66");
        response = test.fetch("13");
        
        response = test.terminalResponse("81030121 80820282 81830100");
        
        // Case 7 : Send envelope formatted SMS with item identifier TLV but without item number
        response = test.envelopeSmsPp(  "8B244008 81556677 887FF600 11291200" +
                                        "00041302 7000000E 0D080000 00200101" +
                                        "00000000 01001000");


        /*********************************************************************/
        /***********************************/        
        /**         Check results          */        
        /***********************************/         
        
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 +
                                    "07CCCCCC CCCCCCCC"));
    
        /*********************************************************************/
        /*********************************************************************/
        /** Restore  card                                                    */
        /*********************************************************************/
                                          
        test.reset();
        test.terminalProfileSession("1719");
        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);
        // Delete Package
        test.deletePackage(CAP_FILE_PATH);   
        
        return getOverallResult();

    }
}   
