//-----------------------------------------------------------------------------
//    Ufw_Apt_Efsu_1.java
//-----------------------------------------------------------------------------

package uicc.usim.test.usatframework.ufw_apt_efsu;

import uicc.toolkit.*;
import uicc.usim.test.util.*;
import javacard.framework.*;


/**
 *
 * Applet is triggered on Install (Install)
 *
 *
 */
public class Ufw_Apt_Efsu_1 extends TestToolkitApplet {
    private static byte[] baMyBuffer = {
            (byte) 0x02, (byte) 0x70, (byte) 0x00, (byte) 0x00, (byte) 0xD0,
            (byte) 0x0D
        };
    private static boolean bRes;
    private static final byte TAG_SMS_TPDU = (byte) 0x8B;
    private byte testCaseNb = (byte) 0;

    /**
    * Constructor of the applet
    */
    public Ufw_Apt_Efsu_1() {
    }

    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) {
        // Create a new applet instance.
        Ufw_Apt_Efsu_1 thisApplet = new Ufw_Apt_Efsu_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short) (bOffset + 1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();

        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
        thisApplet.obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);

        // Test Case 1: 1-is the applet registered to EVENT_FORMATTED_SMS_PP_UPD?
        bRes = thisApplet.obReg.isEventSet(EVENT_FORMATTED_SMS_PP_UPD);
    }

    public void processToolkit(short event) {
        // Get the system instance of the envelope Handler
        EnvelopeHandler envHdlr = EnvelopeHandlerSystem.getTheHandler();

        if (event == EVENT_FORMATTED_SMS_PP_UPD) {
            switch (testCaseNb) {
            case 0:

                // Test Case 1: 1-is the applet registered to EVENT_FORMATTED_SMS_PP_UPD?
                testCaseNb = (byte) 1;
                bRes = true;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 2;

                // Test Case 1: 2-The applet is triggered by Update Record EFsms APDU
                bRes = true;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 3;

                break;

            case 3:

                // Test Case 1: 3- The applet is triggered by Update Record EFsms APDU (concatenated)
                if (envHdlr.findAndCompareValue(TAG_SMS_TPDU, (byte) 1,
                            (short) 0x11, baMyBuffer, (short) 0,
                            (short) baMyBuffer.length) == 0) {
                    bRes = true;
                } else {
                    bRes = false;
                }

                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 4;

                // Test Case 2: The applet is deregistered to EVENT_FORMATTED_SMS_PP_UPD
                try {
                    obReg.clearEvent(EVENT_FORMATTED_SMS_PP_UPD);
                } catch (Exception e) {
                    bRes = false;
                }

                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 5;

                //1/2-The applet is not triggered by EVENT_FORMATTED_SMS_PP_UPD (concatenated)
                bRes = true;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 6;

                break;

            case 6:

                // Test Case 2: 1/2-The applet shall not be triggered               
                // if the applet is triggered the test fails
                bRes = false;
                testCaseNb = (byte) 5;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 6;

            case 7:

                // Test Case 2: 3-The applet is triggered by Update Record EFsms APDU
                bRes = true;
                reportTestOutcome(testCaseNb, bRes);
                testCaseNb = (byte) 8;

                break;

            case 8:

                // 4-The applet is triggered by Update Record EFsms APDU (concatenated)
                if (envHdlr.findAndCompareValue(TAG_SMS_TPDU, (byte) 1,
                            (short) 0x11, baMyBuffer, (short) 0,
                            (short) baMyBuffer.length) == 0) {
                    bRes = true;
                } else {
                    bRes = false;
                }

                reportTestOutcome(testCaseNb, bRes);

                break;
            }
        }

        if ((event == EVENT_UNRECOGNIZED_ENVELOPE) && (testCaseNb == (byte) 6)) {
            try {
                obReg.setEvent(EVENT_FORMATTED_SMS_PP_UPD);
                bRes = true;
            } catch (Exception e) {
                bRes = false;
            }

            reportTestOutcome(testCaseNb, bRes);
            testCaseNb = (byte) 7;
        }
    }
}
