//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_apt_eucb;

import org._3gpp.ct.wg6.usim.jcapi.userclass.*;
import org.etsi.scp.wg3.uicc.jcapi.userclass.*;

//-----------------------------------------------------------------------------
//  Imports
//-----------------------------------------------------------------------------
import org.etsi.scp.wg3.uicc.jcapi.userinterface.*;


public class Test_Ufw_Apt_Eucb extends UiccTestModel {
    static final String CAP_FILE_PATH = "uicc/usim/test/usatframework/ufw_apt_eucb";
    static final String CLASS_AID_1   = "A0000000 871005FF FFFFFF89 50010001";
    static final String APPLET_AID_1  = "A0000000 871005FF FFFFFF89 50010102";
    
    static final String SMS_U_CB = "0C580000 00000000 00000000 00000000 00000000 00000000" +
                                   "00000000 00000000 00000000 00000000 00000000 00000000" +
                                   "00000000 00000000 00000000 00000000 00000000 00000000" +
                                   "00000000 00000000 00000000 00000000 0000";
    
    static final String SMS_F_SINGLE = "8B244008 81556677 887FF600 11291200 00041302" +
                                       "7000000E 0D080000 00500101 00000000 0100";
    
    private USimAPITestCardService test;
    APDUResponse response;

    public Test_Ufw_Apt_Eucb() {
        test = USimAPITestCardService.getTheUSimTestCardService();
    }

    public boolean run() {
        initialiseResults();

        // test script
        test.reset();
        test.terminalProfileSession("1719");

        // Install package
        test.loadPackage(CAP_FILE_PATH);

        // Install Applet1
        test.installApplet(CAP_FILE_PATH, CLASS_AID_1, APPLET_AID_1,
            "8008" + // TLV UICC Toolkit application specific parameters
            "01" + // V Priority Level
            "00" + // V Max. number of timers
            "00" + // V Maximum text length for a menu entry
            "00" + // V Maximum number of menu entries                              
            "00" + // V Maximum number of channels 
            "00" + // LV Minimum Security Level field
            "00" + // LV TAR Value(s) 
            "00"); // V Maximum number of services

        test.reset();
        test.terminalProfileSession("1719");
        
        /**
         * Testcase 1
         */

        addResult(test.envelopeCellBroadcast(SMS_U_CB).checkSw("9000"));

        /**
         * Testcase 2
         */

        addResult(test.envelopeCellBroadcast(SMS_U_CB).checkSw("9000"));
        addResult(test.envelopeSmsPp(SMS_F_SINGLE).checkSw("9000"));
        addResult(test.envelopeCellBroadcast(SMS_U_CB).checkSw("9000"));
        
        
        
        /***********************************/
        /**         Check results          */
        /***********************************/
        // Select applet1
        response = test.selectApplication(APPLET_AID_1);
        addResult(response.checkData("10" + APPLET_AID_1 + "05CCCCCC CCCC"));

        test.reset();
        test.terminalProfileSession("1719");

        // Delete Applet1 
        test.deleteApplet(APPLET_AID_1);

        // Delete Package
        test.deletePackage(CAP_FILE_PATH);

        return getOverallResult();
    }
}
