//-----------------------------------------------------------------------------
//Ufw_Fws_Ouda_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------
package uicc.usim.test.usatframework.ufw_fws_ouda;

import uicc.toolkit.*;
import uicc.usim.test.util.*;
import uicc.usim.toolkit.*;

//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------

/**
 * Test Area : uicc.usim.test.ufwk.ufw_fws_ouda
 *
 * @version 0.0.1 - 9 sept. 2005
 * @author 3GPP T3 SWG API
 */
public class Ufw_Fws_Ouda_1 extends TestToolkitApplet implements uicc.usim.toolkit.ToolkitConstants
{
    // Number of tests
    byte testCaseNb = (byte) 0x00;
    
    private static final byte NO_TRIGGERING_IN_THIS_TEST_CASE = (byte)0x05;
    private static final byte WAIT_FOR_USER_TO_CLEAR_MESSAGE = (byte)0x80;
    private static final short BEGINNING_OF_STRING = (short)0x00;
    private static final byte[] DATA2POST = {(byte)0x41, (byte)0x50, (byte)0x50, (byte)0x4C, (byte)0x45, (byte)0x54, (byte)0x31} ;
                                              
    byte[] buffer = new byte[25];
    
    /**
    * Constructor of the applet
    */
    public Ufw_Fws_Ouda_1 () 
    {
    }
    
    
    /**
    * Method called by the JCRE at the installation of the applet
    */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        Ufw_Fws_Ouda_1  thisApplet = new Ufw_Fws_Ouda_1 ();
        
        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        
        // Initialise the data of the test applet
        thisApplet.init(); 
        
        //register to EVENT_FORMATTED_SMS_PP_ENV
        thisApplet.obReg.setEvent(EVENT_FORMATTED_SMS_PP_ENV);
    }
    
    
    /**
     * Method called by the SIM Toolkit Framework
    */
    public void processToolkit(short event) 
    {
        // Result of each test
        boolean bRes = false;

        // Get the system instance of the EnvelopeHandler class
        USATEnvelopeHandler envHdlr = USATEnvelopeHandlerSystem.getTheHandler();

        // Get the system instance of the EnvelopeResponseHandler class
        EnvelopeResponseHandler envRespHandler = EnvelopeResponseHandlerSystem.getTheHandler();

        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler() ;

        // Sets the test case number
        testCaseNb++;

        short length = 0;
        short offset = 0;
        byte data = 0;

        byte DCS_8_BIT_DATA = (byte) 0x04;
        
        switch ( testCaseNb )
            {
                case (byte) 1 :
                // --------------------------------------------
                // Test Case 1:
                // The SPI in the incoming envelope defines the following features:
                // Ciphering; Cryptographic checksum; proof of receipt response shall be sent using SMS-Deliver-Report;
                // no security shall be applied to proof of receipt.
                //
                // The data carried by this envelope is the string (in plain text) "APPLET1"
                try {
                    bRes = false;
                    offset = envHdlr.getSecuredDataOffset();
                    length = envHdlr.getSecuredDataLength();
                    envHdlr.copyValue(offset, buffer, (short)0x00, length);
                    proHdlr.initDisplayText(WAIT_FOR_USER_TO_CLEAR_MESSAGE, DCS_8_BIT_DATA, buffer, BEGINNING_OF_STRING, length) ;
                    proHdlr.send();
                    bRes = true;
                    }
                catch (Exception e)    {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                break;

                case (byte) 2 :
                // --------------------------------------------
                // Test Case 2:
                // The SPI in the incoming envelope defines the following features:
                // Ciphering; Cryptographic checksum; proof of receipt response shall be sent using SMS-Deliver-Report;
                // no security shall be applied to proof of receipt.
                //
                // The data carried by this envelope is the string (in plain text) "APPLET1"
                try {
                    bRes = false;
                    offset = envHdlr.getSecuredDataOffset();
                    length = envHdlr.getSecuredDataLength();
                    envHdlr.copyValue(offset, buffer, (short)0x00, length);
                    envRespHandler.appendArray(buffer, (short)0x00, length);
                    envRespHandler.post(true);

                    bRes = true;
                    }
                catch (Exception e)    {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                break;

                case (byte) 3 :
                // --------------------------------------------
                // Test Case 3:
                // The SPI in the incoming envelope defines the following features:
                // Ciphering; Cryptographic checksum; proof of receipt response shall be sent using SMS-Deliver-Report;
                // no security shall be applied to proof of receipt.
                //
                // The data carried by this envelope is the string (in plain text) "TEST"

                case (byte) 4 :
                // --------------------------------------------
                // Test Case 4:
                // With respect to test case 3, the same activities shall be performed by the test applet.
                // The only difference lies in the behavior required to the framework (in the incoming
                // envelope the byte SPI2 defines that the proof of receipt shall be cyphered).
                //

                try {
                    bRes = false;
                    offset = envHdlr.getSecuredDataOffset();
                    length = envHdlr.getSecuredDataLength();
                    envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, length);
                    proHdlr.initDisplayText(WAIT_FOR_USER_TO_CLEAR_MESSAGE, DCS_8_BIT_DATA, buffer, BEGINNING_OF_STRING, length) ;

                    envRespHandler.appendArray(DATA2POST, (short)0x00, (short)DATA2POST.length);
                    envRespHandler.post(/*SW1_RP_ACK*/true);

                    proHdlr.send();
                    bRes = true;
                    }
                catch (Exception e)    {
                    bRes = false;
                }
                reportTestOutcome(testCaseNb, bRes);
                break;

                case (byte) 5 :
                // --------------------------------------------
                // Test Case 5:
                // The applet shall not be triggered, (wrong cryptographic checksum)
                // The framework shall send back a proof of receipt with error code '01'
                //
                reportTestOutcome(NO_TRIGGERING_IN_THIS_TEST_CASE, false);
                break;
            }

    }
}
