//-----------------------------------------------------------------------------
//Package Definition
//-----------------------------------------------------------------------------

package uicc.usim.test.usatframework.ufw_hin_enhd;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------


import javacard.framework.*;
import uicc.toolkit.ProactiveHandler;
import uicc.toolkit.ProactiveHandlerSystem;
import uicc.toolkit.ProactiveResponseHandlerSystem;
import uicc.toolkit.ProactiveResponseHandler;
import uicc.toolkit.EnvelopeHandler;
import uicc.toolkit.EnvelopeHandlerSystem;
import uicc.usim.access.USIMConstants;
import uicc.usim.test.util.TestToolkitApplet;


public class Ufw_Hin_Enhd_1 extends TestToolkitApplet {


    /** number of the actual test case */
    private byte    testCaseNb = (byte) 0x01;

    /** flag for test case 1. will be set to true if triggered */
    private boolean bRes       = false;

    private final static byte TAG_SMS_TPDU = (byte)0x0B;

    private final static byte TAG_CELL_BROADCAST_PAGE = (byte)0x0C;

    private final static byte TAG_SERVICE_CENTER_ADDR =(byte)0x06;

    private byte result = (byte)0xFF;

    private byte comparebuffer1[] = new byte[100];
    private byte comparebuffer2[] = new byte[20];

    /** contains the value of envelope call control by naa*/
    private final  byte naa_value[] = new byte[]{(byte)0x82,(byte)0x02,(byte)0x82, (byte)0x81,
                                                 (byte)0x86,(byte)0x02,(byte)0x81, (byte)0x01,
                                                 (byte)0x93,(byte)0x07,(byte)0x81, (byte)0xF2,
                                                 (byte)0xA3,(byte)0x34,(byte)0x05, (byte)0x76,
                                                 (byte)0x67};

    private byte disptextbuffer[] = new byte[]{(byte)0xA1,(byte)0xB2,(byte)0xC3,(byte)0xD4,(byte)0xE5};


    /**
     * Method called by the JCRE at the installation of the applet.
     */
    public static void install(byte[] bArray, short bOffset, byte bLength) throws ISOException
    {
        // Create a new applet instance.
        Ufw_Hin_Enhd_1 applet = new Ufw_Hin_Enhd_1();

        // Register the new applet instance to the JCRE
        applet.register(bArray, (short) (bOffset + 1), bArray[bOffset]);


        // Initialise the data of the test applet.
        applet.init();

        short[] eventList = new short[] {
                                        EVENT_FORMATTED_SMS_CB,
                                        EVENT_FORMATTED_SMS_PP_ENV,
                                        EVENT_FORMATTED_SMS_PP_UPD,
                                        EVENT_UNFORMATTED_SMS_CB,
                                        EVENT_UNFORMATTED_SMS_PP_ENV,
                                        EVENT_UNFORMATTED_SMS_PP_UPD,
                                        EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM,
                                        EVENT_CALL_CONTROL_BY_NAA,
                                        };
        //register to all events defined in 3gpp 31.130
        applet.obReg.setEventList(eventList,(short)0,(short)eventList.length);
    }//end install method


    /**
     * Test: ProactiveResponseHandler TLV list shall be empty before the first
     * call to the ProactiveHandler.send() method
     */
    public void processToolkit(short event) throws ISOException
    {
        bRes = false;
        EnvelopeHandler envHdlr = EnvelopeHandlerSystem.getTheHandler();
        try{

            switch (event){
                //--------------------------------------------------------
                //TC 1
                //--------------------------------------------------------
                case EVENT_FORMATTED_SMS_PP_ENV:

                    testCaseNb=(byte)0x01;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[envHdlr.getLength()];
                    envHdlr.copy(comparebuffer1,(short)0,envHdlr.getLength());

                    if(envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND) {
                        byte dev_id[]= new byte[] {(byte)0x83,(byte)0x81};
                        result|=envHdlr.compareValue((short)0,dev_id,(short)0,(short)dev_id.length);
                    }
                    else {result=(byte)0x01;}//comparison  failed

                    if(envHdlr.findTLV(TAG_SERVICE_CENTER_ADDR,(byte)0x01)!=TLV_NOT_FOUND) {
                        byte serv_addr[]= new byte[] {(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00,(byte)0x00};
                        result|=envHdlr.compareValue((short)0,serv_addr,(short)0,(short)serv_addr.length);
                    }
                    else {result=(byte)0x02;}//comparison  failed


                    if( envHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                       //before terminal response to display text a envelope call controll by naa is send
                       //check that SMS TPDU is still the selected TLV structure
                       byte smstpdu[] = new byte[]{(byte)0x40, (byte)0x0B, (byte)0xD0, (byte)0x21,
                                                   (byte)0x43, (byte)0x65, (byte)0x87, (byte)0x09,
                                                   (byte)0xF1, (byte)0x7F, (byte)0xF6, (byte)0xFF,
                                                   (byte)0xFF, (byte)0xFF, (byte)0xFF, (byte)0xFF,
                                                   (byte)0xFF, (byte)0xFF, (byte)0x1E, (byte)0x02,
                                                   (byte)0x70, (byte)0x00, (byte)0x00, (byte)0x19,
                                                   (byte)0x0D, (byte)0x00, (byte)0x00, (byte)0x00,
                                                   (byte)0x00, (byte)0x50, (byte)0x01, (byte)0x01,
                                                   (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
                                                   (byte)0x00, (byte)0x00, (byte)0xA1, (byte)0xB2,
                                                   (byte)0xC3, (byte)0xD3, (byte)0xE4, (byte)0xF5,
                                                   (byte)0xAA, (byte)0xBB, (byte)0xCC, (byte)0xDD,
                                                   (byte)0xEE};
                       result|=envHdlr.compareValue((short)0,smstpdu,(short)0,(short)smstpdu.length);

                       //content of EnvelopeHanlder shall be the same just like the beginning
                       comparebuffer2=new byte[(short)envHdlr.getLength()];
                       envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                       result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                       if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                break;
                //--------------------------------------------------------
                //TC 2
                //--------------------------------------------------------
                case EVENT_FORMATTED_SMS_PP_UPD:

                    testCaseNb=(byte)0x02;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[envHdlr.getLength()];
                    envHdlr.copy(comparebuffer1,(short)0,envHdlr.getLength());
                    if( envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND){
                        byte dev_id[]= new byte[] {(byte)0x01,(byte)0x03};
                        result|=envHdlr.compareValue((short)0,dev_id,(short)0,(short)dev_id.length);
                    }
                    else {
                        result=(byte)0x01;
                    }

                    if( envHdlr.findTLV(TAG_ADDRESS,(byte)0x01)!=TLV_NOT_FOUND){
                        byte serv_addr[]= new byte[] {(byte)0x80,(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44};
                        result|=envHdlr.compareValue((short)0,serv_addr,(short)0,(short)serv_addr.length);
                    }
                    else { result=(byte)0x01;}

                    if( envHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){

                        sendDisplayText();
                        byte smstpdu[]= new byte[]{ (byte)0x40, (byte)0x02, (byte)0x81, (byte)0x55,
                                                  (byte)0x7F, (byte)0xF6, (byte)0x00, (byte)0x11,
                                                  (byte)0x29, (byte)0x12, (byte)0x00, (byte)0x00,
                                                  (byte)0x04, (byte)0x3D, (byte)0x02, (byte)0x70,
                                                  (byte)0x00, (byte)0x00, (byte)0x38, (byte)0x0D,
                                                  (byte)0x08, (byte)0x00, (byte)0x00, (byte)0x00,
                                                  (byte)0x50, (byte)0x01, (byte)0x01, (byte)0x00,
                                                  (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x01,
                                                  (byte)0x00, (byte)0x11, (byte)0x22, (byte)0x33,
                                                  (byte)0x44, (byte)0x55, (byte)0x66, (byte)0x77,
                                                  (byte)0x88, (byte)0x99, (byte)0x10, (byte)0x11,
                                                  (byte)0x12, (byte)0x13, (byte)0x14, (byte)0x15,
                                                  (byte)0x16, (byte)0x17, (byte)0x18, (byte)0x19,
                                                  (byte)0x1A, (byte)0x1B, (byte)0x1C, (byte)0x1D,
                                                  (byte)0x1E, (byte)0x1F, (byte)0x20, (byte)0x24,
                                                  (byte)0x22, (byte)0x23, (byte)0x24, (byte)0x25,
                                                  (byte)0x26, (byte)0x27, (byte)0x28, (byte)0x29,
                                                  (byte)0x2A, (byte)0x2B, (byte)0x2C, (byte)0x2D,
                                                  (byte)0x2E, (byte)0x2F, (byte)0x30};
                        result|=envHdlr.compareValue((short)0,smstpdu,(short)0,(short)smstpdu.length);

                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)envHdlr.getLength()];
                        envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                 break;
                 //--------------------------------------------------------
                 //TC 3
                 //--------------------------------------------------------
                case EVENT_UNFORMATTED_SMS_PP_ENV:

                    testCaseNb=(byte)0x03;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[envHdlr.getLength()];

                    envHdlr.copy(comparebuffer1,(short)0,envHdlr.getLength());
                    if( envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte deviceid[]= new byte[]{(byte)0x83,(byte)0x81 };
                        result|=envHdlr.compareValue((short)0,deviceid,(short)0,(short)deviceid.length);
                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)envHdlr.getLength()];
                        envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);

                        if( envHdlr.findTLV(TAG_SERVICE_CENTER_ADDR,(byte)0x01)!=TLV_NOT_FOUND){
                            byte serv_addr[]= new byte[] {(byte)0x80,(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44};
                            result|=envHdlr.compareValue((short)0,serv_addr,(short)0,(short)serv_addr.length);
                        }
                        else {result=(byte)0x01;}//comparison  failed

                        if( envHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                           byte smstpdu[]= new byte[]{ (byte)0x00 ,(byte)0x08 ,(byte)0x81 ,(byte)0x55
                                                      ,(byte)0x66 ,(byte)0x77 ,(byte)0x88 ,(byte)0x7F
                                                      ,(byte)0xF6 ,(byte)0x00 ,(byte)0x11 ,(byte)0x29
                                                      ,(byte)0x12 ,(byte)0x00 ,(byte)0x00 ,(byte)0x04
                                                      ,(byte)0x01 ,(byte)0x01};
                           result|=envHdlr.compareValue((short)0,smstpdu,(short)0,(short)smstpdu.length);

                        }
                        else {result=(byte)0x02;}//comparison  failed
                    }
                   else {result=(byte)0x01;}//comparision failed

                   if (result==(byte)0x00){bRes=true;}
                   reportTestOutcome(testCaseNb,bRes);
                break;
                //--------------------------------------------------------
                //TC 4
                //--------------------------------------------------------
                case EVENT_UNFORMATTED_SMS_PP_UPD:

                    testCaseNb=(byte)0x04;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[envHdlr.getLength()];
                    envHdlr.copy(comparebuffer1,(short)0,envHdlr.getLength());
                    if( envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND){
                        byte dev_id[]= new byte[] {(byte)0x01,(byte)0x03};
                        result|=envHdlr.compareValue((short)0,dev_id,(short)0,(short)dev_id.length);
                    }
                    else {
                        result=(byte)0x01;
                    }
                    if( envHdlr.findTLV(TAG_ADDRESS,(byte)0x01)!=TLV_NOT_FOUND){
                        byte serv_addr[]= new byte[] {(byte)0x80,(byte)0x11,(byte)0x22,(byte)0x33,(byte)0x44};
                        result|=envHdlr.compareValue((short)0,serv_addr,(short)0,(short)serv_addr.length);
                    }
                    else { result=(byte)0x01;}

                    if( envHdlr.findTLV(TAG_SMS_TPDU,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte smstpdu[]= new byte[]{ (byte)0x00, (byte)0x02, (byte)0x81, (byte)0x55,
                                                    (byte)0x7F, (byte)0xF6, (byte)0x00, (byte)0x11,
                                                    (byte)0x29, (byte)0x12, (byte)0x00, (byte)0x00,
                                                    (byte)0x04, (byte)0x3D, (byte)0x01, (byte)0x02,
                                                    (byte)0x03, (byte)0x04, (byte)0x05, (byte)0x06,
                                                    (byte)0x07, (byte)0x08, (byte)0x09, (byte)0x0A,
                                                    (byte)0x0B, (byte)0x0C, (byte)0x0D, (byte)0x0E,
                                                    (byte)0x0F, (byte)0x10, (byte)0x11, (byte)0x12,
                                                    (byte)0x13, (byte)0x14, (byte)0x15, (byte)0x16,
                                                    (byte)0x17, (byte)0x18, (byte)0x19, (byte)0x1A,
                                                    (byte)0x1B, (byte)0x1C, (byte)0x1D, (byte)0x1E,
                                                    (byte)0x1F, (byte)0x20, (byte)0x21, (byte)0x22,
                                                    (byte)0x23, (byte)0x24, (byte)0x25, (byte)0x26,
                                                    (byte)0x27, (byte)0x28, (byte)0x29, (byte)0x2A,
                                                    (byte)0x2B, (byte)0x2C, (byte)0x2D, (byte)0x2E,
                                                    (byte)0x2F, (byte)0x30, (byte)0x31, (byte)0x32,
                                                    (byte)0x33, (byte)0x34, (byte)0x35, (byte)0x36,
                                                    (byte)0x37, (byte)0x38, (byte)0x39, (byte)0x3A,
                                                    (byte)0x3B, (byte)0x3C, (byte)0x3D };
                        result|=envHdlr.compareValue((short)0,smstpdu,(short)0,(short)smstpdu.length);

                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)envHdlr.getLength()];
                        envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                break;
                //--------------------------------------------------------
                //TC 5
                //--------------------------------------------------------
                case EVENT_UNFORMATTED_SMS_CB:

                    testCaseNb=(byte)0x05;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[envHdlr.getLength()];
                    envHdlr.copy(comparebuffer1,(short)0,envHdlr.getLength());

                    if(envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND) {
                        byte dev_id[]= new byte[] {(byte)0x83,(byte)0x81};
                        result|=envHdlr.compareValue((short)0,dev_id,(short)0,(short)dev_id.length);
                    }
                    else {result=(byte)0x01;}//comparison  failed


                    if( envHdlr.findTLV(TAG_CELL_BROADCAST_PAGE,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte cbpage[]= new byte[]{  (byte)0xA7, (byte)0x51, (byte)0x10, (byte)0xA0,
                                                    (byte)0xF6, (byte)0x11, (byte)0x00, (byte)0x30,
                                                    (byte)0x0D, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x50, (byte)0x01, (byte)0x01,
                                                    (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x00, (byte)0x01, (byte)0x02,
                                                    (byte)0x03, (byte)0x04, (byte)0x05, (byte)0x06,
                                                    (byte)0x07, (byte)0x08, (byte)0x09, (byte)0x0A,
                                                    (byte)0x0B, (byte)0x0C, (byte)0x0D, (byte)0x0E,
                                                    (byte)0x0F, (byte)0x10, (byte)0x11, (byte)0x12,
                                                    (byte)0x13, (byte)0x14, (byte)0x15, (byte)0x16,
                                                    (byte)0x17, (byte)0x18, (byte)0x19, (byte)0x1A,
                                                    (byte)0x1B, (byte)0x1C, (byte)0x1D, (byte)0x1E,
                                                    (byte)0x1F, (byte)0x20, (byte)0x21, (byte)0x22,
                                                    (byte)0x23, (byte)0x24, (byte)0x25, (byte)0x26,
                                                    (byte)0x27, (byte)0x28, (byte)0x29, (byte)0x2A,
                                                    (byte)0x2B, (byte)0x2C, (byte)0x2D, (byte)0x2E,
                                                    (byte)0x2F, (byte)0x30, (byte)0x31, (byte)0x32,
                                                    (byte)0x33, (byte)0x34, (byte)0x35, (byte)0x36,
                                                    (byte)0x37, (byte)0x38, (byte)0x39, (byte)0x3A,
                                                    (byte)0x3B, (byte)0x3C, (byte)0x3D, (byte)0x3E,
                                                    (byte)0x3F, (byte)0x40, (byte)0x41, (byte)0x42};
                        result|=envHdlr.compareValue((short)0,cbpage,(short)0,(short)cbpage.length);

                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)envHdlr.getLength()];
                        envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                break;
                //--------------------------------------------------------
                //TC 6
                //--------------------------------------------------------
                case EVENT_MO_SHORT_MESSAGE_CONTROL_BY_SIM:

                    testCaseNb=(byte)0x06;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[envHdlr.getLength()];
                    envHdlr.copy(comparebuffer1,(short)0,envHdlr.getLength());
                    if(envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND) {
                        byte dev_id[]= new byte[] {(byte)0x82,(byte)0x81};
                        result|=envHdlr.compareValue((short)0,dev_id,(short)0,(short)dev_id.length);
                    }
                    else {result=(byte)0x01;}//comparison  failed

                    if( envHdlr.findTLV(TAG_ADDRESS,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte address[]= new byte[]{(byte)0x81, (byte)0x33, (byte)0x22, (byte)0x55,
                                                   (byte)0x11};
                        result|=envHdlr.compareValue((short)0,address,(short)0,(short)address.length);
                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)envHdlr.getLength()];
                        envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    break;
                //--------------------------------------------------------
                //TC 7
                //--------------------------------------------------------
                case EVENT_FORMATTED_SMS_CB:

                    testCaseNb=(byte)0x07;
                    result=(byte)0x00; //
                    //copy content of envelope handler to buffer
                    comparebuffer1 = new byte[envHdlr.getLength()];
                    envHdlr.copy(comparebuffer1,(short)0,envHdlr.getLength());
                    if(envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)!=TLV_NOT_FOUND) {
                        byte dev_id[]= new byte[] {(byte)0x83,(byte)0x81};
                        result|=envHdlr.compareValue((short)0,dev_id,(short)0,(short)dev_id.length);
                    }
                    else {result=(byte)0x01;}//comparison  failed

                    if( envHdlr.findTLV(TAG_CELL_BROADCAST_PAGE,(byte)0x01)!=TLV_NOT_FOUND){
                        sendDisplayText();
                        byte cbpage[]= new byte[]{  (byte)0xA7, (byte)0x50, (byte)0x10, (byte)0x93,
                                                    (byte)0xF6, (byte)0x11, (byte)0x00, (byte)0x30,
                                                    (byte)0x0D, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x50, (byte)0x01, (byte)0x01,
                                                    (byte)0x00, (byte)0x00, (byte)0x00, (byte)0x00,
                                                    (byte)0x00, (byte)0x00, (byte)0x01, (byte)0x02,
                                                    (byte)0x03, (byte)0x04, (byte)0x05, (byte)0x06,
                                                    (byte)0x07, (byte)0x08, (byte)0x09, (byte)0x0A,
                                                    (byte)0x0B, (byte)0x0C, (byte)0x0D, (byte)0x0E,
                                                    (byte)0x0F, (byte)0x10, (byte)0x11, (byte)0x12,
                                                    (byte)0x13, (byte)0x14, (byte)0x15, (byte)0x16,
                                                    (byte)0x17, (byte)0x18, (byte)0x19, (byte)0x1A,
                                                    (byte)0x1B, (byte)0x1C, (byte)0x1D, (byte)0x1E,
                                                    (byte)0x1F, (byte)0x20, (byte)0x21, (byte)0x22,
                                                    (byte)0x23, (byte)0x24, (byte)0x25, (byte)0x26,
                                                    (byte)0x27, (byte)0x28, (byte)0x29, (byte)0x2A,
                                                    (byte)0x2B, (byte)0x2C, (byte)0x2D, (byte)0x2E,
                                                    (byte)0x2F, (byte)0x30, (byte)0x31, (byte)0x32,
                                                    (byte)0x33, (byte)0x34, (byte)0x35, (byte)0x36,
                                                    (byte)0x37, (byte)0x38, (byte)0x39, (byte)0x3A,
                                                    (byte)0x3B, (byte)0x3C, (byte)0x3D, (byte)0x3E,
                                                    (byte)0x3F, (byte)0x40, (byte)0x41, (byte)0x42};
                        result|=envHdlr.compareValue((short)0,cbpage,(short)0,(short)cbpage.length);

                        //content of EnvelopeHanlder shall be the same just like the beginning
                        comparebuffer2=new byte[(short)envHdlr.getLength()];
                        envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                        result |= Util.arrayCompare(comparebuffer1,(short)0,comparebuffer2,(short)0,(short)comparebuffer2.length);
                        if (result==(byte)0x00){bRes=true;}
                    }
                    reportTestOutcome(testCaseNb,bRes);
                    break;
                //--------------------------------------------------------
                //
                //--------------------------------------------------------
                case EVENT_CALL_CONTROL_BY_NAA:
                    //check the content of the envelope handler
                    //shall contain: DEVICE_ID,ADDRESS and LOCATION INFORMATION TLVs
                    //82 02 82 81   86 02 81 01   93 07 81 F2 A3 34 05 76 67
                    envHdlr.copy(comparebuffer2,(short)0,(short)envHdlr.getLength());
                    result |= Util.arrayCompare(comparebuffer2,(short)0,naa_value,(short)0,(short)naa_value.length);
                    //tag dev_id shall be selectable
                    if (envHdlr.findTLV(TAG_DEVICE_IDENTITIES,(byte)0x01)==TLV_NOT_FOUND) {
                        result=(byte)0xFF;
                    }
                break; //EVENT_CALL_CONTROLL_BY_NAA

            }

        }
        //no exceptions shall be thrown during the test
        catch(Exception ex){
            reportTestOutcome(testCaseNb,bRes);
        }


    }//end processToolkit method

    /**
     * Sends a display text
     */
    private void sendDisplayText(){
        ProactiveHandler proHdlr = ProactiveHandlerSystem.getTheHandler();
        proHdlr.initDisplayText((byte)0x80,(byte)0x04,disptextbuffer,(short)0x00,(short)disptextbuffer.length);
        proHdlr.send();
    }

}//end of class Ufw_Hin_Prhd_1