//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//Package Definition
//----------------------------------------------------------------------------- 
package uicc.usim.test.usatframework.ufw_mha_pahd;
//-----------------------------------------------------------------------------
//Imports
//-----------------------------------------------------------------------------
import javacard.framework.*;
import uicc.toolkit.*;
import uicc.usim.test.util.* ;


public class Ufw_Mha_Pahd_2 extends TestToolkitApplet {
    /** result of specific testcase */
    boolean         bRes    = false;
    /** number of testcase */
    byte          testCaseNb  = (byte) 0x00;
    private final short     eventList[] = { 
                        EVENT_UNFORMATTED_SMS_PP_ENV,
                        EVENT_UNFORMATTED_SMS_CB,
                        EVENT_UNFORMATTED_SMS_PP_UPD};  
    
    /**
     */
    private Ufw_Mha_Pahd_2 () {
  
    }
  
    public static void install(byte[] bArray, short bOffset, byte bLength) {
 
         
        // Create a new applet instance.
        Ufw_Mha_Pahd_2 thisApplet = new Ufw_Mha_Pahd_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        thisApplet.init();
              
        //- Applet registration     
        thisApplet.obReg.setEventList(thisApplet.eventList,(short)0,(short)(thisApplet.eventList.length));
    }
    
  
    public void processToolkit(short event) throws ToolkitException {
        bRes=false;
      
        switch(event){
  
            case EVENT_UNFORMATTED_SMS_PP_ENV:
                if (testCaseNb<(byte)0x01){
                  testCaseNb=(byte)0x01;
                  getProactiveHandler(testCaseNb);
                }
                else{
                  testCaseNb++; //0x04 if applet is triggered
                  //ProactiveHandler is not available before the TerminalProfile
                  getProactiveHandlerNotAvailableException(testCaseNb);
                  
                }
                break;

            case EVENT_UNFORMATTED_SMS_PP_UPD:
                if (testCaseNb<(byte)0x02){
                  testCaseNb=(byte)0x02;
                  getProactiveHandler(testCaseNb);
                }
                else{
                  testCaseNb++; //0x05 if applet is triggered
                  //ProactiveHandler is not available before the TerminalProfile
                  getProactiveHandlerNotAvailableException(testCaseNb);
                  
                }
                break;
                   
            case EVENT_UNFORMATTED_SMS_CB:
                if (testCaseNb<(byte)0x03){
                  testCaseNb=(byte)0x03;
                  getProactiveHandler(testCaseNb);
                }
                else{
                  testCaseNb++; //0x06 if applet is triggered
                  //ProactiveHandler is not available before the TerminalProfile
                  getProactiveHandlerNotAvailableException(testCaseNb);
                  
                }
                break;              
    }
  }

  /**
   * Applet get the Proactive Handler. <br>
   * If successful the test case will be reported as
   * successful. Otherwise as failed.s
   * 
   * @param testCaseNb number of test case
   */ 
  private void getProactiveHandler(byte testCaseNb) {
    bRes=false;
    try {
      //get the Proactive Handler
      ProactiveHandler proHdr = ProactiveHandlerSystem.getTheHandler();
      bRes=true;
    }
    catch(Exception exp) {
      bRes=false;
    }
    this.reportTestOutcome(testCaseNb,bRes);
  }
  
  /**
   * Methods try to get a instance of the ProactiveHandler class. If this
   * fails and a ToolkitException.HANDLER_NOT_AVAILABLE is thrown, the test
   * case will be reported as successful. Otherwise as failure.
   * 
   * @param testCaseNb Number of the current test case
   */
  private void getProactiveHandlerNotAvailableException(byte testCaseNb) {
    bRes=false;
    try {
      //get the Proactive Handler
      ProactiveHandler proHdr = ProactiveHandlerSystem.getTheHandler();
    }
    catch (ToolkitException e) {
      if (e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE) {
        bRes=true;
      }
    }
    catch(Exception exp) {
      bRes=false;
    }
    this.reportTestOutcome(testCaseNb,bRes);
  }
  
  
  
  

}